#ifndef STRUCTS

	#include "config.h"

	#if defined (MSDOS) || defined (X68000)
		#define	FIRST_MTRK_SIZE		8192	/* MTrk reallocs par FIRST_MTRK_SIZE */
		#define	MTRK_OVERFLOW_RANGE	1024	/* MTrk reallocs if memory lasts MTRK_OVERFLOW_RANGE */
	#else
		#define	FIRST_MTRK_SIZE		65536	/* MTrk reallocs par FIRST_MTRK_SIZE */
		#define	MTRK_OVERFLOW_RANGE	1024	/* MTrk reallocs if memory lasts MTRK_OVERFLOW_RANGE */
	#endif

	#define	TERMINATOR	0xFF			/* binary/text file gurdian (EOF code) */

	typedef struct {
		BYTE	ch;						/* channel no. (set by @n,etc) */
		BYTE	ch_;					/* channel no. (set by (AMIDI1,1),etc: initial set) */
		UBYTE	*zmd;					/* ZMDdata pointer */
		UBYTE	*zmdbuf;				/* ZMDdata buffer address */
		DWORD	buforgsize;				/* original buffer size, set in (Mx,xxxx) */
		DWORD	bufsize;				/* buffer size */
		DWORD	nowsize;				/* buffer size used now */
		DWORD	total;					/* total steps (w/o loop)*/
		DWORD	backinuse;				/* NOUSE==-1, USE=backtrk */
	} TRKCHINF;


	typedef struct {
		DWORD	maxtrk;					
		WORD	gtreso;					/* gatetime_resolution */
		WORD	tempo;
		UBYTE	div;
		BYTE	basech;
		BYTE	debug;
		BYTE	trkassign[80 + 1];
		BYTE	backtrk[80 + 1];		/* track which will be used for [back ...] */
		BYTE	fromtrk[80 + 1];		/* return track from [back...] */
		BYTE	l1tie;
		BYTE	renpmode;				/* 1 or 2: 1/2byte step/gate mode */
		UBYTE	fmvol;					/* fm_master_volume */
		UBYTE	adpcmbank;				/* adpcm_bank */
		UBYTE	opmtone[55];			/* fm tone data */
		UBYTE	polpcm;					/* pcm8 track */
		UBYTE	m1setup[127];			/* m1 setup data */
		UBYTE	sc55id;					/* default device id */
		UBYTE	mt32id;					/* default device id */
		UBYTE	u220id;					/* default device id */
		BYTE	qmode;					/* quantize_mode */
		BYTE	usedwav[32 - 8];		/* used wave table no. */
	} COMMONINF;




	#define STRUCTS
#endif	/* STRUCTS */
