#ifndef STRUCTS2

	#include "config.h"

	typedef struct loopData {
		struct loopData *next;
		struct loopData *prev;
		DWORD	loopstart;	/* loop start positon */
		DWORD	loopskip;	/* whether | or |n */
		BYTE	loopmode;	/* */
		DWORD	looptime;	/* times of loop */
		DWORD	looptime2;	/* times of :| */
		DWORD	totalstart;	/* total's value at the start of loop */
		DWORD	totalmode;	/* -1=no |,|n  0= w/| 1=w/|n */
	} LOOPDATA;

	typedef struct renp {
		struct renp *next;
		struct renp *prev;
		DWORD	step;
		WORD	qvar;
		BYTE	qrelflg;
		BYTE	pflg;		/* portament? */
	} RENP;

	typedef struct {		/* [0]: var  [1]: random parameter */
		WORD	var[2];
		BYTE	relflg[2];		/* 0:abs 1:rel 2:omit 3:* -1:guardian */
	} VELOETCVAR;

	typedef struct chkstep {
		struct chkstep *next;
		struct chkstep *prev;
		UDWORD	step;		/* total's value at the start of {{...}} */
	} CHKSTEP;

	typedef struct linedata {
		struct	linedata	*next;
		char	*filename;
		DWORD	line;
	} LINEDATA;

	typedef struct linefiledata {
		struct	linefiledata	*next;
		char	*filename;
	} LINEFILEDATA;

	typedef struct back {
		struct back *next;
		struct back *prev;
	} BACK;
	#define	BACKEVENT	0;


	typedef struct event {
		struct back *next;
		struct back *prev;
		int code;
	} EVENT;

	typedef struct {
		BYTE		ksign[12];
		BYTE		octave;
		DWORD		total;
		UWORD		Step;
		UWORD		laststep;
		VELOETCVAR	velou,*velocity,*quantize,mod[17],arcc[17];
/*
		LOOPDATA	l[9];
		LOOPDATA	d[9];
*/
		BYTE		lpos,dpos;
		WORD		relvelo;		/* +127 - -128 */
		UBYTE		nowvelo;
		BYTE		veloseqsw;
		BYTE		velozpos,quantizepos,modpos,arccpos;
		BYTE		veloznum,quantizenum,modnum,arccnum;			/* 0:none */
		/* BYTE		vol; */
		BYTE		randvelotype;
		UWORD		randvelopower;
		BYTE		relvol;
		BYTE		relpan;
		BYTE		transpose;
		BYTE		abdelay;
		BYTE		pdelay;
		BYTE		cdelay;
 		BYTE		fadeout;
		BYTE		spvelomode;
		DWORD		renpnotes;
		LOOPDATA	*l;
		LOOPDATA	*d;					/* only "looptime" is used */
		RENP		*r;
		CHKSTEP		*s;
		BACK		*b;
		EVENT		*e;

		COMMONINF *cominf;
		BYTE back_repeat;
	} TRKINF;

	#define STRUCTS2
#endif
