#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "makezmd1.h"
#include "makezmd2.h"
#include "v3macro.h"
#include "etc.h"
#define	MAXTRK		(80 + 1)
#define	COMNTRKSIZE	8192
#include "structs.h"
#include "structs2.h"
TRKCHINF *makeZmd(UBYTE *zmsbuf, char *infile,COMMONINF *cominf);
DWORD line = 1, linebak = 1;
char *linebuf = NULL;
char *infile;
LINEDATA *ld, *ldorg;
LINEFILEDATA *lfd, *lfdorg;
TRKCHINF *makeZmd(UBYTE *zmsbuf, char *infile_,COMMONINF *cominf)
{
	int i, trks;
	TRKCHINF *trkdata;
	UBYTE *zms2;
	ld = ldorg = (LINEDATA*)emalloc(sizeof(LINEDATA) * 1, "LINEDATA");
	lfd = lfdorg = (LINEFILEDATA*)emalloc(sizeof(LINEFILEDATA) * 1, "LINEFILEDATA");
	lfd->next = NULL;
	lfd->filename = (char*)emalloc(sizeof(char*) * (strlen(infile_) + 1), "lfd->filename_in_makezmd");
	strcpy(lfd->filename,infile_);
	ld->next = NULL;
	ld->filename = lfd->filename;
	ld->line = 1;
	infile = (char*)emalloc(sizeof(char) * (strlen(infile_) + 1), "infile_in_makezmd");
	strcpy(infile,infile_);
	cominf->maxtrk = MAXTRK;
	zmsbuf = expandV3macro(zmsbuf, ld, lfd);
	trkdata = (TRKCHINF*)emalloc(sizeof(TRKCHINF) * cominf->maxtrk, "trkdata_in_makezmd");
	linebuf = zmsbuf;
	cominf->trkassign[0] = -1;
	cominf->renpmode     = 1;
	for (i = 0; i < cominf->maxtrk; i++) {
		trkdata[i].ch = trkdata[i].ch_ = -1;
		cominf->backtrk[i] = cominf->fromtrk[i] = -1;
	}
	for (i = 0; i < 32 - 8; i++) {
		cominf->usedwav[i] = 0;
	}
	trkdata[0].zmdbuf  = (UBYTE*)emalloc(sizeof(UBYTE) * COMNTRKSIZE, "trkdata[0].zmdbuf");
	trkdata[0].bufsize = COMNTRKSIZE;
	trkdata[0].zmd     = trkdata[0].zmdbuf;
	trkdata[0].nowsize = 0;
	makeZmdCommon(trkdata,zmsbuf,&zms2,cominf);
	for (i = 0, trks = 0; cominf->trkassign[i] >= 0; i++, trks++) {
		const int t = cominf->trkassign[i];
		trkdata[t].zmdbuf    = (UBYTE*)emalloc(sizeof(UBYTE) * COMNTRKSIZE, "trkdata[t].zmdbuf");
		trkdata[t].bufsize   = COMNTRKSIZE;
		trkdata[t].zmd       = trkdata[t].zmdbuf;
		trkdata[t].nowsize   = 0;
		trkdata[t].backinuse = -1;
	}
	for (i = trks; i < cominf->maxtrk; i++) {
		/* trkdata[i].zmdbuf = NULL; */
	}
	/* makeZmdMain(trkdata,zms,&zms2,infile_,cominf,trkinf); */
	makeZmdMain(trkdata,zms2,&zms2,cominf);
	while (ldorg->next) {
		ld = ldorg;
		ldorg = ldorg->next;
		efree(ld, "ld");
	}
	efree(ldorg, "ldorg");
	while (lfdorg->next) {
		lfd = lfdorg;
		lfdorg = lfdorg->next;
		efree(lfd->filename, "lfd->filename");
		efree(lfd, "lfd");
	}
	efree(lfdorg, "LINEFILEDATA");
	/* trkdata[0].nowsize = trkdata[0].zmd - trkdata[0].zmdbuf; */
	efree(infile, "infile_in_makezmd");
	efree(zmsbuf, "zmsbuf_in_makezmd"); 		/* free the memory for macro expanded zms) */
	return trkdata;
}