#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "switch.h"
#include "makezmd.h"
#include "makezmd2.h"
#include "velo.h"
#include "etc.h"
#include "68lib.h"
/* ryk ==> */
#ifdef ZMC2_STATIC_LIB	/* Static lib */
	#include "setjmp.h"
	extern jmp_buf g_zmc2mark;
#endif
/* <== ryk */
/* #define	MAXTRK		(80 + 1) */		/* includes from makezmd.h */
/* #define	MAXTRK		(80) */
/* #define	COMNTRKSIZE	8192 */
#include "structs.h"
#include "structs2.h"
inline LINEDATA *incrementLine(LINEDATA *ld);
void resetError(void);
UBYTE *skipComment(UBYTE *zms);
UBYTE *skipSpc(UBYTE *zms);
UBYTE *skipSpcCr(UBYTE *zms);
int stricmp2(char *str1,const char *str2);
void zmserror(const char *errormes,char *linebuf,char *zms,int warnlvl,int putzms);
UBYTE *getnum2(UBYTE *zms,DWORD *num,int *err);
UBYTE *getnum3(UBYTE *zms,DWORD *num,int *err);
UBYTE *setex(UBYTE *zmd, UBYTE *data, DWORD len, int mode);
UBYTE *txt2bin(UBYTE *zmd, UBYTE *zms,DWORD *zmsbyte);
UBYTE *exclusive(UBYTE *zmd, UBYTE *zms,UBYTE f0f7, DWORD *zmsskip,
					UBYTE roland,UBYTE dev,UBYTE mdl,
					DWORD postlen, UBYTE *postdata,
					char *leftbrace,char *rightbrace);
UBYTE *skiptochr(UBYTE *zms,char *skip);
UBYTE *skipchr(UBYTE *zms,char *skip);
UBYTE *getStep(UBYTE *zms, UWORD *step, UWORD Step,int *err,COMMONINF *cominf);
UBYTE *getpara(UBYTE *zms, VELOETCVAR v[], int *paras);
UBYTE *getvpara(UBYTE *zms, VELOETCVAR **v, int *paras);
UBYTE *get1AbsPara(UBYTE *zms,DWORD *para,DWORD rangefrom,DWORD rangeto,
					char *outofrange,char *omitpara);
UBYTE *setTie(UBYTE *zms,TRKCHINF *trkdata,const int Trk,TRKINF *trkinf,
				UBYTE note,UWORD *step, UWORD *gate, BYTE relvelo, int omitgate,
				UWORD Step,COMMONINF *cominf);
UBYTE *setTie2(UBYTE *zms,TRKCHINF *trkdata,const int Trk,TRKINF *trkinf,
				UBYTE note,UWORD *step, UWORD gate, BYTE relvelo,COMMONINF *cominf);
UBYTE *set98Tie(UBYTE *zms, UWORD *step, UWORD Step,COMMONINF *cominf,int *err);
UWORD getGate1(const int Trk,TRKINF *trkinf,UWORD Step);
void checkRenpu(TRKCHINF *trkdata, const int Trk,TRKINF *trkinf,int pflg);
UBYTE *makeRenpuStepGate(UBYTE *zms, const BYTE target[],TRKCHINF *trkdata,TRKINF *trkinf,
						COMMONINF *cominf);
void makePortBresemhamPara(WORD br,WORD *add,WORD *cor,UWORD step);
void setVelocitySequenceMode(TRKINF *trkinf,const BYTE trk,int mode);
UWORD getGate2(WORD qver,BYTE qrel,UWORD Step, WORD gtreso);
inline void recoverSpecialVelocity(TRKINF *trkinf, TRKCHINF *trkdata, int Trk);
UBYTE *checkOctaveChange(UBYTE *zms,TRKINF *trkinf,const int Trk);
void incrementStepCounters(TRKINF *trkinf, UWORD step);
extern char *linebuf;
static char *zms__ = NULL;
extern char *infile;
extern LINEDATA *ld;
extern LINEFILEDATA *lfd;
void resetError(void)
{
	zms__ = NULL;
}
inline LINEDATA *incrementLine(LINEDATA *ld)
{
	if (ld->next) {
		ld = ld->next;
	}
	return ld;
}
UBYTE *skipComment(UBYTE *zms)
{
	while(*zms != nativeCR) {
/*
		if (*zms == 0xff && *(zms + 1) == 0xff) {
			break;
		}
*/
		zms++;
	}
/* del v1.33 (as CR code is converted into single char)
	if (*zms == 0x0d && *(zms + 1) == 0x0a) {
		zms += 2;
	} else {
		zms++;
	}
*/
	zms++;
	linebuf = zms;
	ld = incrementLine(ld);
	return zms;
}
UBYTE *skipSpc(UBYTE *zms)
{
	while (*zms == ' ' || *zms == '\t' || *zms == '/') {
		if (*zms == '/') {
			zms = skipComment(zms);
		} else {
			zms++;
		}
	}
	return zms;
}
/* ================================
     skip "space" and "return"
   ================================ */
UBYTE *skipSpcCr(UBYTE *zms)
{
	while (1) {
		switch (*zms) {
			case 0xff:
				if (*(zms + 1) == 0xff) break;
				zms++;
				continue;
#ifdef aa
/* del v1.33 (as CR code is converted into single char)
			case 0x0d:
				if (*(zms + 1) == 0x0a) zms++;	/* NO BREAK */
			case 0x0a:
#endif
			case nativeCR:
				linebuf = ++zms;
				ld = incrementLine(ld);
				continue;
			case '/':
				zms = skipComment(zms);
				continue;
			case ' ':
			case '\t':
				zms++;
				continue;
			default:
				break;
		}
		break;
	}
	return zms;
}
/* ======================================================
     strings compare, (it must strlen(str1) >= strlen(str2) )
   ====================================================== */
int stricmp2(char *str1,const char *str2)
{
	/* const int len1 = strlen(str1); */
	const int len2 = strlen(str2);
	/* char s1[1024]; */
	char tmp;
	int rc;
	/* s1 = (char*)emalloc(sizeof(char) * len1 + 1); */
/*
	strncpy(s1,str1,len2);
	s1[len2] = '\0';
*/
	tmp = str1[len2];
	str1[len2] = '\0';
	rc = stricmp(str1,str2);		/* caseless strings compare */
	/* free(s1); */
	str1[len2] = tmp;
	return rc;
}
/* =========
     ERROR
     warnlvl: 0=err 1- warn level
   ========= */
void zmserror(const char *errormes,char *linebuf,char *zms,int warnlvl,int putzms)
{
	char *str, *p = linebuf;
	int i,len,len2 = zms - linebuf, regardsw;
	while (*p != nativeCR && *p != 0x1a && *p != (char)-1) {
		p++;
	}
	/* p = skipComment(linebuf); */
	len = p - linebuf;
	if (!getSwitchVal('w') || (zms__ != zms && getSwitchVal('w') >= warnlvl)) {
		char *p,*em;
		em = emalloc(sizeof(char) * (strlen(errormes) + 16), "em");

		if (getSwitchVal('r') == SET_VAL) {
			setSwitchVal('r', getSwitchVal('w'));
		}

		regardsw = getSwitchVal('r');
		if (!warnlvl || (regardsw >= 0 && warnlvl <= regardsw)) {
			strcpy(em,"Error: ");
		} else {
			strcpy(em,"Warning: ");
		}
		strcat(em,errormes);
		zms__ = zms;
		str = emalloc(sizeof(char) * (len + 1), "str");
		if (len) {
			strncpy(str,linebuf,len);
		}
		str[len] = '\0';
		p = str - 1;
		while (*++p) {
			if (*p == 0x1a) {
				*p = '\0';
			}
		}
		if (getSwitchVal('l') != SET_VAL) {
/*			fprintf(stderr,"%s\t%d: %s\n",infile,line,em); */
			ZMC2FormatMessage(stderr,"%s\t%d: %s\n", ld->filename, ld->line, em);
		} else {
/*			fprintf(stderr,"%s\tL%dC%d: %s\n",infile,line,len2 + 1,em); */
			ZMC2FormatMessage(stderr,"%s\tL%dC%d: %s\n", ld->filename, ld->line, len2 + 1, em);
		}
		if (putzms) {
			ZMC2FormatMessage(stderr,"%s\n",str);
			for (i = 0; i < len2; i++) {
				if (str[i] == '\t') {
					ZMC2FormatMessage(stderr,"\t");
				} else {
					ZMC2FormatMessage(stderr," ");
				}
			}
			ZMC2FormatMessage(stderr,"^\n");
		}
		efree(str, "str");
		efree(em, "em");

		if (!warnlvl || (regardsw >= 0 && warnlvl <= regardsw)) {
		/* if (!warnlvl) { */
			terminateProgram(1);
/* ryk ==> */
#ifdef ZMC2_STATIC_LIB	/* Static lib */
			longjmp(g_zmc2mark, 1);
#endif
/* <== ryk */
		}
	}
}
/* =======================================
     text->numeric conversion
     $xx , %xxxx are OK,too
     *err= 0: no err
           1: SYNTAX ERR
          -1: no value
   ======================================== */
UBYTE *getnum_core(UBYTE *zms,DWORD *num,int *err)
{
	BYTE	sign    = 0;
	BYTE	binhex  = 10;
	BYTE	novalue = 1;
#ifdef TOWNSEXT
	DWORD	num2 = 0;
#endif
	*num = 0;
	*err = -1;
	while(1) {
		UBYTE c;
		c = *zms;
		switch (c) {
			case '+':	case '-':
#ifdef TOWNSEXT
				if (!novalue) {
					zmserror("expression can use only for zmc2 TOWNS version.",ld-line,linebuf,zms,4,1);
					num2 += (sign < 0) ? -*num : *num;
					*num = 0;
					sign = (c == '-') ? -1 : 1;
					binhex = 10;
					novalue = 1;
					*err = 1;
					zms++;
					continue;
				}
#else
				if (!novalue) break;
#endif
				if (c == '-')
					sign = sign ? -sign : -1;
				else
					sign = sign ? sign : 1;
				*err = 1;
				zms++;
				continue;
			case '$':	case '%':
				if (!novalue || binhex != 10) break;
				binhex = (c == '$') ? 16 : 2;
				*err = 1;
				zms++;
				continue;
			case 'f':	case 'F':
			case 'e':	case 'E':
			case 'd':	case 'D':
			case 'c':	case 'C':
			case 'b':	case 'B':
			case 'a':	case 'A':
				c = tolower(c) - 'a' + '0' + 10;
			case '8':	case '9':
			case '6':	case '7':
			case '4':	case '5':
			case '2':	case '3':
				if (c - '0' > binhex - 1) break;
			case '0':	case '1':
				*num *= binhex;
				*num += c - '0';
				novalue = 0;
				*err = 0;
				zms++;
				continue;
			case ' ':
			case '\t':
				if (!novalue || !sign) break;
				zmserror("unexpected space.",linebuf,zms,3,1);
				zms++;
				continue;
			default:
				break;
		}
		if (sign < 0) *num = -*num;
#ifdef TOWNSEXT
		if (num2) *num += num2;
#endif
		return zms;
	}
}
UBYTE *getnum2(UBYTE *zms,DWORD *num,int *err) {
	zms = skipSpcCr(zms);
	return getnum_core(zms,num,err);
}
UBYTE *getnum3(UBYTE *zms,DWORD *num,int *err) {
	zms = skipSpc(zms);
	return getnum_core(zms,num,err);
}
/* ===========================================================
     exclusive(low level)
     put "data"s simply. ("len" bytes)
     put Roland/YAMAHA Exclusive additionaly (if "mode" is set.)
   =========================================================== */
UBYTE *setex(UBYTE *zmd, UBYTE *data, DWORD len, int mode)
{
	DWORD i;
	UBYTE sum = 0;
	if (mode == 1 || mode == 2) {		/* with Roland/YAMAHA checksum */
		const DWORD exceptsum = (mode == 1)? 5 : 4;
		for (i = 0; i < exceptsum; i++) {		/* ID,dev,etc.. */
			*zmd++ = *data++;
		}
		if (mode == 2) {				/* for YAMAHA: add block size */
			putWord(zmd, len - exceptsum - 3);
			sum -= *zmd++;
			sum -= *zmd++;
		}
		for (i = exceptsum; i < len; i++) {
			*zmd++ = *data;
			sum -= *data++;
		}
		*zmd++ = sum & 0x7f;
	} else {
		for (i = 0; i < len; i++) {
			*zmd++ = *data++;
		}
	}
	return zmd;
}
/* ========================================
     text->binary conversion
     "strings" supports.
     week point: poor error check
   ======================================== */
UBYTE *txt2bin(UBYTE *zmd, UBYTE *zms, DWORD *zmsbyte)
{
	UBYTE *zms_ = zms;
	DWORD bytes;
	int err;
	DWORD num;
	zms = getnum2(zms,&num,&err);
/* printf("(%d %d)",num,err); */
	bytes = zms - zms_;
	if (err < 0 && *zms == '\"') {							/* "strings" */
		zms++;
		bytes++;
		while (*zms != '\"' && *zms != '\n') {
			*zmd++ = *zms++;
			bytes++;
			if (*zms == 0xff && *(zms + 1) == 0xff) {
				break;
			}
		}
		/* zms++; */			/* add v1.24: to skip '"' */
		bytes++;
	} else if (!err) {										/* numerics */
		do {
			*zmd++ = num & 0x7f;
			num >>= 7;
		} while (num);
	} else if (*zms == ',') {
		/* bytes = -1; */
	}
	*zmsbyte = bytes;
	return zmd;
}
UBYTE *exclusive(UBYTE *zmd, UBYTE *zms,UBYTE f0f7, DWORD *zmsskip,
					UBYTE roland,UBYTE dev,UBYTE mdl,
					DWORD postlen, UBYTE *postdata,
					char *leftbrace,char *rightbrace)
{
	int		len,len2;
	DWORD zmsbyte = 0;
	UBYTE *data = (UBYTE*)emalloc(sizeof(UBYTE) * 8192, "data");
	UBYTE *data_ = data;
	UBYTE *zms_  = zms;
	int lbflg = 0;
	if (f0f7) {
		*data++ = 0xf0;
	}
	if (roland == 1) {
		*data++ = 0x41;				/* Roland maker ID */
		*data++ = dev;
		*data++ = mdl;
		*data++ = 0x12;
	} else if (roland == 2) {
		*data++ = 0x43;				/* YAMAHA maker ID */
		*data++ = dev;
		*data++ = mdl;
	}
	if (postlen) {
		for (len = 0; len < postlen; len++) {
			*data++ = *postdata++;
		}
	}
	if (*leftbrace) {
#ifdef AAA
#ifdef __GNUC__
		char skip[2] = { *leftbrace, '\0' };
#else
		char skip[2] = { '\0','\0' };
		skip[0] = *leftbrace;
#endif
#endif
		/* zms = skiptochr(zms,skip);*/
		zms = skiptochr(zms,leftbrace);
		if (!zms || *zms == 0xFF) {
			zmserror("unexpected EOF.",linebuf,zms_,0,0);
		} else if (!strchr(leftbrace, *zms++)) {	/* *zms++ != *leftbrace) { */
			char str[128];
			sprintf(str,"braces `%s' are not found.",leftbrace);
			zmserror(str,linebuf,zms,0,1);
		}
	} else {
		zms = skipSpcCr(zms);
	}
	if (*leftbrace == '\"') {
		zms--;
		lbflg = 1;
	}
	while (*zms != rightbrace[0] || lbflg) {
		lbflg = 0;
		data = txt2bin(data,zms,&zmsbyte);
		if (zmsbyte >= 0) {		/* if not ',' */
			zms += zmsbyte;
			if (*leftbrace == '\"' && strlen(leftbrace) == 1) {
				/* only "..." strings is allowed ... .sc55_print etc.*/
				zms--;
			}
		}
		if (*zms == '/') {
			zms = skipComment(zms);
		}
		if (!strchr(rightbrace, *zms)) {
			char str[128];
			sprintf(str,"[%c]: illegal partion character.",*zms);
			zmserror(str,linebuf,zms,0,1);
			/* zmserror("illegal partition character.",line,linebuf,zms,0,1); */
		}
		if (*zms == ',') {		/* if ',' */
			zms++;
		} else if (*zms == 0xFF && *(zms + 1) == 0xFF) {	/* EOF */
			zmserror("unexpected EOF.",linebuf,zms_,0,0);
		}
		if (*leftbrace == '\"') {
			break;
		}
	}
	*zmd++ = 0x18;								/* MIDI DATA transfer */
	len2 = len = data - data_;
	if (f0f7)	len2++;							/* len + 1:for 0xF7 */
	if (roland)	len2++;
	putWord(zmd, len2);
	zmd += 2;
	zmd = setex(zmd, data_, len, roland);
	if (f0f7) {
		*zmd++ = 0xf7;
	}
	efree(data_, "data_");
	*zmsskip = zms - zms_ + 1;
	return zmd;
}
/* ==========================
     scan texts "until" skip_characters comes.
     if feof, return NULL.(means ERROR)
   ==========================  */
UBYTE *skiptochr(UBYTE *zms,char *skip)
{
	while ( *zms != 0xFF && !strchr(skip, *zms) ) {
		if (*zms == nativeCR) {
/* del v1.33 (as CR code is converted into single char)
			if (*(zms + 1) == 0x0a) {
				zms += 2;
			} else {
				zms++;
			}
*/
			zms++;
			linebuf = zms;
			ld = incrementLine(ld);
/* del v1.33 (as CR code is converted into single char)
		} else if (*zms == 0x0a) {
			linebuf = ++zms;
			ld = incrementLine(ld);
*/
		} else {
			zms++;
		}
	}
	if (*zms == 0xFF && *(zms + 1) == 0xFF) {
		return NULL;
	} else {
		return zms;
	}
}
/* ==========================
     scan texts "while" skip_characters comes.
     if feof, return NULL.(means ERROR)
   ==========================  */
UBYTE *skipchr(UBYTE *zms,char *skip)
{
	while ( *zms != 0xFF && strchr(skip, *zms) ) {
		if (*zms == nativeCR) {
/* del v1.33 (as CR code is converted into single char)
			if (*(zms + 1) == 0x0a) {
				zms += 2;
			} else {
				zms++;
			}
*/
			zms++;
			linebuf = zms;
			ld = incrementLine(ld);
/* del v1.33 (as CR code is converted into single char)
		} else if (*zms == 0x0a) {
			linebuf = ++zms;
			ld = incrementLine(ld);
*/
		} else {
			zms++;
		}
	}
	if (*zms == 0xFF && *(zms + 1) == 0xFF) {
		return NULL;
	} else {
		return zms;
	}
}
UBYTE *getStep(UBYTE *zms, UWORD *step, UWORD Step,int *err_,COMMONINF *cominf)
{
	UWORD step_ = 0;
	int err;
	DWORD para;
	*err_ = 0;
	zms = getnum2(zms,&para,&err);		/* step parameter */
	if (!err) {
		step_ = (para)? cominf->div / para : 0;
										/* quaternote etc.. (not set ticks directly) */
	} else if (err < 0) {
		if (*zms == '*') {				/* set ticks directry */
			zms = getnum2(++zms,&para,&err);
			if (err) {
				zmserror("`*' must be followed to its parameter.",linebuf,zms,0,1);
			}
			step_ = para;
		} else {						/* no parameters */
			step_ = Step;
			*err_ = 2;
		}
	} else {
		zmserror("SYNTAX ERROR",linebuf,zms,0,1);
	}
	para = step_;						/* "."(dots) */
	while (*zms == '.') {
		para /= 2;
		step_ += para;
		zms = skipSpc(++zms);
		*err_ = 1;
	}
	*step = step_;
	return zms;
}
/* ===========================
     get parameter (1/8 series)
   =========================== */
UBYTE *getpara(UBYTE *zms, VELOETCVAR v[], int *paras)
{
	DWORD velo = 127,znum = 0;
	int i,err;
	zms--;
	do {
		BYTE rel;
		int znumadd = 0;
		for (i = 0; i < 2; i++) {					/* i==  0:velo 1:randompara */
			zms = skipSpcCr(zms + 1);
			/* if (i != 0 && (*zms == '+' || *zms == '-')) { */
			if (*zms == '+' || *zms == '-') {
				rel = 1;
			} else if (*zms == '*'){
				rel = 3;
				zms++;
			} else {
				rel = 0;
			}
			zms = getnum2(zms,&velo,&err);
			if (err < 0) {							/* omit 1st/Xth parameter */
				if (znum != 0) {
					v[znum].var[i]    = v[znum - 1].var[0];
				}
				v[znum].relflg[i] = 2;				/* set "omit-flg" */
				if (*zms == ',' || *zms == ':') {	/* continue.. */
					znumadd = 1;
					/* v[0].var[i]    = 0; */
					/* v[znum].relflg[i] = 2; */	/* set "omit-flg" */
					/* znum = 1; */
				} else {							/* that's all */
/* printf("[V=%d]",velo); */
					/* znum = 0; */
				}
			} else {								/* there is 1st/Xth parameter */
				v[znum].var[i] = velo;
				v[znum].relflg[i] = rel;
				znumadd = 1;
			}
			/* printf("[V=%d]",velo); */
			zms = skipSpcCr(zms);
			if (*zms != ':' || (*zms == ':' && *(zms + 1) == '|')) {
				int j;
				for (j = i + 1; j < 2; j++) {
					v[znum].var[j]    = 0;
					v[znum].relflg[j] = -1;
				}
				break;
			}
		}
		znum += znumadd;
	} while (*zms == ',');
	*paras = znum;
	if (znum > 0 && v[znum - 1].relflg[0] == 2) {		/* if the last parameter is omitted */
		(*paras)--;
	}
	return zms;
}
/* ===========================
     get variable length parameter
   =========================== */
UBYTE *getvpara(UBYTE *zms, VELOETCVAR **vp, int *paras)
{
	DWORD znum = 0;
	DWORD znummax = 8;
	*vp = emalloc(sizeof(VELOETCVAR) * znummax, "*vp");
	zms--;
	do {
		DWORD var;
		int i,err;
		BYTE rel;
		for (i = 0; i < 2; i++) {
			(*vp)[znum].var[i]    = 0;
			(*vp)[znum].relflg[i] = -1;
		}
		for (i = 0; i < 2; i++) {
			zms = skipSpcCr(zms + 1);
			if (*zms == '*') {
				zms++;
				rel = 3;
			} else {
				rel = (*zms == '+' || *zms == '-') ? 1 : 0;
			}
			zms = getnum2(zms,&var,&err);
			if (err) {						/* omit 1st/Xth parameter */
				var = (znum > 0) ? (*vp)[znum - 1].var[0] : 0;
				rel = 2;					/* set "omit-flg" */
			}
			(*vp)[znum].var[i]    = var;
			(*vp)[znum].relflg[i] = rel;
			zms = skipSpcCr(zms);
			if (*zms != ':' || *(zms + 1) == '|') break;
		}
		if (++znum == znummax) {
			znummax += 8;
			*vp = erealloc(*vp, sizeof(VELOETCVAR) * znummax, "vp");
		}
		zms = skipSpcCr(zms);
	} while (*zms == ',');
	/* *vp = erealloc(*vp, sizeof(VELOETCVAR) * znum); */
	if ((*vp)[znum - 1].relflg[0] == 2) {	/* if the last parameter is omitted */
		znum--;
	}
	*paras = znum;
	return zms;
}
/* ==============================
     get parameter(can't omit parameter, cant set parameter relatively)
   ============================== */
UBYTE *get1AbsPara(UBYTE *zms,DWORD *para,DWORD rangefrom,DWORD rangeto,
					char *outofrange,char *omitpara)
{
	UBYTE *zms_ = zms;
	UBYTE *linebuf_ = linebuf;
	int err;
	zms = getnum2(zms,para,&err);
	if (!err) {
		if (rangefrom != rangeto && (*para < rangefrom || rangeto < *para)) {
			zmserror(outofrange,linebuf_,zms_,0,1);
		}
	} else {
		zmserror(omitpara,linebuf_,zms_,0,1);
	}
	return zms;
}
UBYTE *setTie(UBYTE *zms,TRKCHINF *trkdata,const int Trk,TRKINF *trkinf,
				UBYTE note,UWORD *step, UWORD *gate, BYTE relvelo, int omitgate,
				UWORD Step,COMMONINF *cominf)
{
#ifdef _0
	const int Trk = target[trk];
#endif
	int err;
	zms = skipSpcCr(zms);
	zms = set98Tie(zms, step, Step, cominf,&err);
	{							/* add v1.25 */
		UWORD bakgate = *gate;
		int err;
		VELOETCVAR v;
		/* gate */
		zms = getGate(zms,Trk,trkinf,*step,gate,&err,cominf);
		if (err == 2) {
			*gate = bakgate;
		}
		zms = checkOctaveChange(zms,trkinf,Trk);
		/* velo */
		zms = getSpecialVelocity(zms,&v);
		setVelo0(trkdata,Trk,v,&relvelo,trkinf,cominf,*step);
	}
	if (omitgate == 2) {
		*gate = getGate1(Trk,trkinf,*step);
	}
	zms = skipSpcCr(zms);
	if (*zms == '&') {			/* tie */
		*gate = 0xFFFF;
		zms++;
	}
	zms = setTie2(zms,trkdata,Trk,trkinf,
				note,step,*gate,relvelo,cominf);
#ifdef _0
	if (step == 1 && note != 0x80 && cominf->l1tie) {		/* *1 tick */
		*gate = 0xFFFF;
	}
	/* printf("[note,sgv,tie=%d,%d,%d,%d,%d]",note,step,*gate,velo,tie); */
#ifdef AAA
	recoverSpecialVelocity(trkinf, Trk);
#endif
	if (step == 0) {					/* *0  */
		if (*gate == 0xFFFF) {
			/* *data++ = 0xCD; */
			*trkdata[Trk].zmd++ = 0xCD;
		} else {
			*trkdata[Trk].zmd++ = 0xAD;
		}
		*trkdata[Trk].zmd++ = note;
		/* *data++ = note; */
	} else {
		if ((step < 0x100 && (*gate == 0xffff || *gate < 0xff)) || ((trkinf[Trk].renpnotes) && (cominf->renpmode == 1))) {
			*trkdata[Trk].zmd++ = note;
			if (trkinf[Trk].renpnotes) {
				checkRenpu(trkdata,Trk,trkinf,0);
			}
			*trkdata[Trk].zmd++ = step;
			*trkdata[Trk].zmd++ = *gate & 0xFF;
		} else {
			*trkdata[Trk].zmd++ = 0xFE;
			*trkdata[Trk].zmd++ = note;
			putWord(trkdata[Trk].zmd,     step);
			checkRenpu(trkdata,Trk,trkinf,0);
			putWord(trkdata[Trk].zmd + 2, *gate);
			trkdata[Trk].zmd += 4;
		}
		if (relvelo) {
			trkinf[Trk].spvelomode = 1;
			/* *trkdata[Trk].zmd++ = 0x84; */		/* recover special velocity */
		}
	}
	/* printf("[%d]",data - data_); */
	/* *data2 = data; */
#endif
	return zms;
}
UBYTE *setTie2(UBYTE *zms,TRKCHINF *trkdata,const int Trk,TRKINF *trkinf,
				UBYTE note,UWORD *step, UWORD gate, BYTE relvelo,
				COMMONINF *cominf)
{
	/* const int Trk = target[trk]; */
#ifdef _0
	int err;
	zms = skipSpcCr(zms);
	zms = set98Tie(zms, step, Step, cominf,&err);
	if (omitgate == 2) {
		*gate = getGate1(Trk,trkinf,*step);
	}
	zms = skipSpcCr(zms);
	if (*zms == '&') {			/* tie */
		*gate = 0xFFFF;
		zms++;
	}
#endif
	if (*step == 1 && note != 0x80 && cominf->l1tie) {		/* *1 tick */
		gate = 0xFFFF;
	}
	/* printf("[note,sgv,tie=%d,%d,%d,%d,%d]",note,step,*gate,velo,tie); */
#ifdef AAA
	recoverSpecialVelocity(trkinf, Trk);
#endif
	if (*step == 0) {					/* *0  */
		if (gate == 0xFFFF) {
			/* *data++ = 0xCD; */
			*trkdata[Trk].zmd++ = 0xCD;
		} else {
			*trkdata[Trk].zmd++ = 0xAD;
		}
		*trkdata[Trk].zmd++ = note;
		/* *data++ = note; */
	} else {
		if ((*step < 0x100 && (gate == 0xffff || gate < 0xff)) || ((trkinf[Trk].renpnotes) && (cominf->renpmode == 1))) {
			*trkdata[Trk].zmd++ = note;
			if (trkinf[Trk].renpnotes) {
				checkRenpu(trkdata,Trk,trkinf,0);
			}
			*trkdata[Trk].zmd++ = *step;
			*trkdata[Trk].zmd++ = gate & 0xFF;
		} else {
			*trkdata[Trk].zmd++ = 0xFE;
			*trkdata[Trk].zmd++ = note;
			putWord(trkdata[Trk].zmd,     *step);
			checkRenpu(trkdata,Trk,trkinf,0);
			putWord(trkdata[Trk].zmd + 2, gate);
			trkdata[Trk].zmd += 4;
		}
		if (relvelo) {
			trkinf[Trk].spvelomode = 1;
			/* *trkdata[Trk].zmd++ = 0x84; */		/* recover special velocity */
		}
	}
	/* printf("[%d]",data - data_); */
	/* *data2 = data; */
	return zms;
}
UBYTE *set98Tie(UBYTE *zms, UWORD *step, UWORD Step,COMMONINF *cominf, int *err)
{
	*err = 2;				/* no parameter */

	zms = skipSpc(zms);
	while (*zms == '^') {	/* 98 tie */
		UWORD addstep;
		int err_;
#ifdef	TOWNSEXT
		if (*(++zms) == '-') {
			zmserror("^- can use only for zmc2 TOWNS version.",linebuf,zms - 1,4,1);
			zms = getStep(zms + 1, &addstep, Step, &err_,cominf);
			if (err_ != 2) {
				*err = 0;
			}
			*step -= addstep;
		} else {
			zms = getStep(zms, &addstep, Step, &err_,cominf);
/*			del v1.31
			if (err_ != 2) {
				*err = 0;
			}
*/
			*err = 0;	/* add v1.31 */
			*step += addstep;
		}
#else
		zms = getStep(++zms, &addstep, Step, &err_,cominf);
/*		delete v1.31
		if (err_ != 2) {
			*err = 0;
		}
*/
		*err = 0;	/* add v1.31 */
		*step += addstep;
#endif
		zms = skipSpcCr(zms);
	}
	return zms;
}
/* ======================================
     get gate without numeric parameter
   ====================================== */
UWORD getGate1(const int Trk,TRKINF *trkinf,UWORD Step)
{
	/* const int Trk = target[Trk]; */
	BYTE *qpos = &(trkinf[Trk].quantizepos);
	WORD qvar = trkinf[Trk].quantize[*qpos].var[0];
	BYTE qrel = trkinf[Trk].quantize[*qpos].relflg[0];
	return getGate2(qvar,qrel,Step, trkinf[Trk].cominf->gtreso);
}
UWORD getGate2(WORD qvar,BYTE qrel,UWORD Step, WORD gtreso)
{
	UWORD gate;
	if (qrel == 1) {
		if (qvar < 0 || Step > qvar) {
			gate = Step - qvar;
		} else {
			gate = Step;
		}
	} else if (qrel == 3) {
		if (Step < qvar) {
			gate = Step;
		} else {
			gate = qvar;
		}
	} else {
		gate = Step * qvar / gtreso;
		if (gate == 0) {
			gate = 1;
		}
	}
	return gate;
}
void checkRenpu(TRKCHINF *trkdata, const int Trk,TRKINF *trkinf,int pflg)
{
	/* const int Trk = target[Trk]; */
	if (trkinf[Trk].renpnotes) {			/* renpu? */
		BYTE *qpos = &(trkinf[Trk].quantizepos);
		trkinf[Trk].renpnotes++;
		trkinf[Trk].r->step       = trkdata[Trk].zmd - trkdata[Trk].zmdbuf;
		trkinf[Trk].r->qvar       = trkinf[Trk].quantize[*qpos].var[0];
		trkinf[Trk].r->qrelflg    = trkinf[Trk].quantize[*qpos].relflg[0];
		trkinf[Trk].r->pflg       = pflg;
		trkinf[Trk].r->next       = (RENP*)emalloc(sizeof(RENP) * 1, "trkinf[Trk].r->next");
		trkinf[Trk].r->next->prev = trkinf[Trk].r;
		trkinf[Trk].r             = trkinf[Trk].r->next;
		trkinf[Trk].r->next       = NULL;
	}
}
UBYTE *makeRenpuStepGate(UBYTE *zms, const BYTE target[],TRKCHINF *trkdata,TRKINF *trkinf,
						COMMONINF *cominf)
{
	int trk;
	UBYTE *zms_ = zms;
	int warnoct = 0;
	for (trk = 0; target[trk] >= 0; trk++) {
		const int Trk = target[trk];
		const int beforeOctave = trkinf[Trk].octave;
		UWORD step, step1,stepincs;
		DWORD i;
		int err;
		BYTE tieflag = 0;		/* become 1 when {..}nn& */
		if (trkinf[Trk].r->prev == NULL) {
			if (trkinf[Trk].renpnotes == 1) {
				trkinf[Trk].renpnotes = 0;
				return zms;					/* for the data {} (NULL renpu) */
			} else {
				zmserror("no { found..",linebuf,zms,0,1);
			}
		}
		zms = getStep(zms_, &step, trkinf[Trk].Step,&err,cominf);
		zms = skipSpcCr(zms);
		zms = checkOctaveChange(zms,trkinf,Trk);
		zms = skipSpcCr(zms);
		zms = set98Tie(zms,&step,trkinf[Trk].Step,cominf,&err);
		zms = skipSpcCr(zms);
		trkinf[Trk].total += step;
		if (*zms == '&') {
			tieflag = 1;
			zms++;
		}
		if (tieflag && beforeOctave != trkinf[Trk].octave && !warnoct) {
			zmserror("There is octave switch(es) between NOTE and TIE.",linebuf,zms,3,1);
			warnoct = 1;
		}
		step1 = step / (trkinf[Trk].renpnotes - 1);
		stepincs = step % (trkinf[Trk].renpnotes - 1);
		incrementStepCounters(&trkinf[Trk],step);
#ifdef AAA
		if (trkinf[Trk].s->prev) {
			trkinf[Trk].s->step += step;
		}
#endif
		for (i = trkinf[Trk].renpnotes - 1; i > 0; i--) {
			UWORD step_ = step1;
			UWORD stepold;
			UWORD gateold;
			UBYTE *RenpuStepPos;
			trkinf[Trk].r = trkinf[Trk].r->prev;
			RenpuStepPos = trkdata[Trk].zmdbuf + trkinf[Trk].r->step;
			efree(trkinf[Trk].r->next, "trkinf[Trk].r->next");
			trkinf[Trk].r->next = NULL;
			if (i <= stepincs) {
				step_++;
			}
			stepold = getWord(RenpuStepPos);
			if (cominf->renpmode == 1 && trkinf[Trk].r->pflg == 0) {
				*RenpuStepPos = step_;
			} else {
				putWord(RenpuStepPos, step_);
			}
			if (trkinf[Trk].r->pflg == 1) {							/* portament */
				WORD br = 0,add,cor,cor0 = 0;
				UWORD j, delayold;
				delayold = getWord(RenpuStepPos + 4);
				add = getWord(RenpuStepPos + 6);			/* get bend range */
				cor = *(RenpuStepPos + 8);
				for (j = 0; j < stepold - delayold; j++) {
					br += add;
					cor0 += cor;
					if (cor0 > 0xFF) {
						br++;
						cor0 -= 0x100;
					}
				}
				step_ -= delayold;										/* make new add/cor */
				/* br  = (note[1] - note[0]) * 683; */		/* bend range */
				makePortBresemhamPara(br,&add,&cor,step_);
				putWord(RenpuStepPos + 6, add);			/* set new add/cor */
				*(RenpuStepPos + 8) = cor & 0xFF;
			}
			if (cominf->renpmode == 1 && trkinf[Trk].r->pflg == 0) {
				gateold = *(RenpuStepPos + 1);
				if (gateold == 0xFF) {
					gateold = 0xFFFF;
				}
			} else {
				gateold = getWord(RenpuStepPos + 2);
			}
			if (i == trkinf[Trk].renpnotes - 1 && tieflag) {		/* {..}nn& */
				gateold = 0xFFFF;
				if (cominf->renpmode == 1 && trkinf[Trk].r->pflg == 0) {
					*(RenpuStepPos + 1) = gateold;
				} else {
					putWord(RenpuStepPos + 2, gateold);
				}
			}
			if (gateold != 0xFFFF) {				/* not TIE */
				WORD qvar = trkinf[Trk].r->qvar;
				BYTE qrel = trkinf[Trk].r->qrelflg;
				UWORD gate;
				gate = getGate2(qvar,qrel,step_,cominf->gtreso);
				if (cominf->renpmode == 1 && trkinf[Trk].r->pflg == 0) {
					*(RenpuStepPos + 1) = gate;
				} else {
					putWord(RenpuStepPos + 2, gate);
				}
			}
			trkinf[Trk].r->pflg = 0;
		}
		trkinf[Trk].renpnotes = 0;
	}
	return zms;
}
void makePortBresemhamPara(WORD br,WORD *add,WORD *cor,UWORD step)
{
	if (step) {
		DWORD tempcor;
		if (br < 0) {
			br = -br;
			*add = -(br / step);
		} else {
			*add = br / step;
		}
		tempcor  = ((DWORD)br % step) * 256;
		br       = tempcor % step;		/* br: temporary */
		tempcor /= step;
		if (br) {
			tempcor++;
		}
		*cor = tempcor;
	} else {
		*add = *cor = 0;
	}
}
void setVelocitySequenceMode(TRKINF *trkinf,const BYTE trk,int mode)
{
	trkinf[trk].velou.relflg[0] = mode;
}
inline void recoverSpecialVelocity(TRKINF *trkinf, TRKCHINF *trkdata, int Trk)
{
	if (trkinf[Trk].spvelomode) {
		*trkdata[Trk].zmd++ = 0x84;		/* recover special velocity */
		trkinf[Trk].spvelomode = 0;
	}
}
UBYTE *checkOctaveChange(UBYTE *zms,TRKINF *trkinf,const int Trk)
{
	while (*zms == '<' || *zms == '>') {
		if (*zms == '<') {
			trkinf[Trk].octave++;
		} else {
			trkinf[Trk].octave--;
		}
		if (trkinf[Trk].octave < -1 || 9 < trkinf[Trk].octave) {
			zmserror("octave parameter is out of range(-1 - 9).",linebuf,zms,0,1);
		}
		zms++;
	}
	return zms;
}
void incrementStepCounters(TRKINF *trkinf, UWORD step)
{
	if (!(trkinf->renpnotes)) {
		trkinf->total += step;
/*
		if (trkinf->s->prev) {
			trkinf->s->step += step;
		}
*/
	}
}